#pragma once

/******---------        INTEGER HANDLING UTILS        ---------******/

#if COMPILER_ID == MSC_ID
#include mergestring(ATuints_,COMPILER.h)
#endif

/* Macros isneg and ispos.*/
#if 0
/*This does not work. The C standard insists in promoting the operand to int even for unary operators.
This is clearly a flaw in the language. It makes the result wrong at better (the first one always tests to true),
implementation dependent at somewhat worse, and the program to abort suddenly at worst, all these
even for unsigned types.*/
#define isneg(x) ((x)>~(x))
#define ispos(x) ((x)<~(x))
#endif
/* Because of this it is impossible to define a simple generic macro working in all possible scenarios.
It would be, did the C standard implement a typeof() operand:
( (x)>(typeof(x))(~(unsigned long long)(x)) )*/
#include "posneg.cod"

//Accessing individual bytes
#include "byteaccess.cod"

//Swaping of bytes from/to little endian, big endian and the processor's native sorting
#include "byteswap.cod"
