#pragma once
//fread está mal en Windows
//La función en Windows solamente lee 0x36ee000 bytes = 56248 KB = 14062 K uints
//Leer en dos mitades no sirve porque lo hace mal. Además, el valor devuelto por la
//función es mucho menor de lo realmente leído.
#if !defined(_WIN32)
	#include <stdio.h>
	#define FILE_TYPE FILE*
	#define FOPEN_B(i,_path_) i=fopen(_path_,"r")
	#define BAD_FILE NULL
	#define FCLOSE(i) fclose(i)
	#define FREAD(buffer,i,size_field,n_fields) fread(buffer,size_field,n_fields,i)
#else
	#include <io.h>
	#include <fcntl.h>
	#define FILE_TYPE int
	#define FOPEN_B(i,_path_) i=_open(_path_,_O_RDONLY|_O_BINARY)
	#define BAD_FILE -1
	#define FCLOSE(i) _close(i)
	#define FREAD(buffer,i,size_field,n_fields) (_read(i,buffer,size_field*n_fields)/size_field)
#endif
#define OPEN_FAILURE(i) ((i)==BAD_FILE)
