//#include mergestring(_wstring_,SYSTEM.c)

#ifndef IGNORE_ALL

/*Look at strconv_C.c for some explanations*/
#ifndef FUNCTION_double___str16
double double___str16(iconst char16_t **ps){
	const char16_t *s1=*ps;
	bint signo=0;
	double x=0, z;
	int e;
	unsigned int c;
	if(*s1=='-'){signo=1; s1++;}
	else if(*s1=='+') s1++;

//integerpart:
	while((c=*s1-u'0')<10){
		x*=10; x+=c;
		s1++;
	}
	c+='0';
	if(c=='.' || c==',') goto decimalpart;
	if(c=='e' || c=='E') goto exponent;
	goto _return;
decimalpart:
	z=0.1;	//The precision of a double is far more than I need
	while((c=*++s1-u'0')<10){
		x+=c*z; z*=0.1;	//and, further, dividing does not increase error
	}
	c+='0';
	if(c!='e' && c!='E') goto _return;
exponent:
	if(signo) x=-x;
	if(*++s1=='-'){signo=1; s1++;}
	else{signo=0; if(*s1=='+') s1++;}
	if(*s1=='0') s1++;	//very likely
	e=0;
	if(*s1=='0') s1++;
	while((c=*s1-u'0')<10){
		e*=10; e+=c;
		s1++;
	}
	if(signo){
		while(e>7){x*=0.00000001; e-=8;}
		x*=pot10neg[e];
	}else{
		while(e>7){x*=100000000.0; e-=8;}
		x*=pot10pos[e];
	}
	goto _exp_return;

_return:
	if(signo) x=-x;
_exp_return:
	*ps=s1;
	return x;
}
#endif

//Here the separator can only be '.'. vf stands for very fast
#ifndef FUNCTION_vfdouble___str16
double vfdouble___str16(iconst char16_t **ps){
	const char16_t *s1=*ps;
	bint signo=0;
	double x=0, z;
	unsigned int c;
	if(*s1=='-'){signo=1; s1++;}
	else if(*s1=='+') s1++;

//integerpart:
	while((c=*s1-u'0')<10){
		x*=10; x+=c;
		s1++;
	}
	if(c+'0'=='.'){	//decimalpart:
		z=0.1;
		while((c=*++s1-'0')<10){
			x+=c*z; z*=0.1;	//and, further, dividing does not increase error
		}
	}

	if(signo) x=-x;
	*ps=s1;
	return x;
}
#endif

#ifndef FUNCTION_ssint___str16
ssint ssint___str16(iconst char16_t **ps){
	const char16_t *s1=*ps;
	bint signo=0;
	unsigned int c, x=0;
	ssint sx;

	if(*s1==u'-'){signo=1; s1++;}
	else if(*s1==u'+') s1++;
	while((c=*s1-u'0')<10){ s1++;
		x*=10; x+=c;
	}
	ifunlike(x>0x7fffFfff) x=0x7fffFfff;
	sx=(ssint)x;
	if(signo) sx=-sx;

	*ps=s1;
	return sx;
}
#endif

#ifndef FUNCTION_uint_check___str16
uint uint_check___str16(iconst char16_t** ps){
	const char16_t *s1=*ps;
	uint c, x=0;
	const uint M=0xffffFfffU / 10;

	ifunlike(*s1=='+') s1++;
	while(*s1=='0') s1++;
	if((c=*s1-'0')>=10) goto salida;
	x=c; s1++; //Primera cifra
	while((c=*s1-'0')<10){
		ifunlike(x>M) goto salida_mala;
		x*=10; x+=c;
		ifunlike(x<10) goto salida_mala;
		s1++;
	}
	goto salida;

salida_mala:
	x=-1U;
salida:
	*ps=s1;
	return (uint)x;
}
#endif

#ifndef FUNCTION_ssint_check___str16
ssint ssint_check___str16(iconst char16_t** ps){
	const char16_t *s1=*ps;
	bint signo=0;
	uint c, x=0;
	ssint sx;
	const uint M1=0x7fffFfffU / 10;
	const uint M2=0x80000000U;

	if(*s1==u'+') s1++;
	else if(*s1==u'-'){signo=1; s1++;}
	while((c=*s1-u'0')<10){
		ifunlike(x>M1) goto salida_mala;
		x*=10; x+=c;
		ifunlike(x>=M2) goto salida_mala;
		s1++;
	}
	sx=(ssint)x;
	if(signo) sx=-sx;
	goto salida;

salida_mala:
	sx=-0x7fffFfff-1;
salida:
	*ps=s1;
	return sx;
}
#endif

#ifndef FUNCTION_basedinteger___str16
uint basedinteger___str16(iconst char16_t **ps){
	if(**ps==u'0'){
		char16_t c;
		(*ps)++;
		c=*(*ps)++;
		switch(c){
			case u'h': case u'x': return hex___str16(ps);
			case u'd': return uint___str16(ps);
			case u'c': return oct___str16(ps);
			case u'b': return bin___str16(ps);
		}
		(*ps)--;
	}
	return 0;
}
#endif

#ifndef FUNCTION_str16___uint
char16_t* str16___uint(char16_t* ptr, uint x){
	char16_t *fin;
	ptr+=ncifras(x);
	fin=ptr--;
	while(x>=10){
		uint y=x/10;
		*ptr--=(char16_t)(x-10*y+u'0');
		x=y;
	}
	*ptr=(char16_t)x+u'0';
	return fin;
}
#endif

#ifndef FUNCTION_str16___t_min
char16_t* str16___t_min(char16_t* ptr, uint t_min, umint bl){
	const char16_t * const sm[3]={u" m",u" min",u" minutos"};
	ifunlike(bl>2) bl=2;

	if(t_min>=60){
		uint h=t_min/60;
		ptr=str16___uint(ptr,h); *ptr++=u' '; *ptr++=u'h'; *ptr++=u' ';
		t_min-=h*60;
	}
	ptr=str16___uint(ptr,t_min);
	ptr=strpcpy16(ptr,sm[bl]);
	return ptr;
}
#endif

#ifndef FUNCTION_c16___u8
//Returns s8 advanced
char8_t* c16___u8(char16_t *s1, iconst char8_t* s8){
	iflike(!(*s8&0x80)){*s1=*s8; return (ICONST char8_t*)(s8+1);}
	ifunlike(!(*s8&0x40)){
		*s1=0x25CA;	//Rombo
		do s8++; while((*s8&0xC0)==0x80);	//Bad bytes here
		return (ICONST char8_t*)s8;
	}

	//11...
	u8int n;
	if(!(*s8&0x20)) n=2, *s1=*s8&0x1F;
	else if(!(*s8&0x10)) n=3, *s1=*s8&0xF;
	else iflike(!(*s8&0x80)) n=4, *s1=*s8&0x7;
	else{
		*s1=0x25CA;
		do s8++; while((*s8&0xC0)==0x80);
		return (ICONST char8_t*)s8;
	}
	s8++, n--;
	while(n && (*s8&0xC0)==0x80){
		*s1<<=6; *s1|= *s8&0x3F;
		s8++, n--;
	}
	if(n!=0) *s1=0x25CA;
	return (ICONST char8_t*)s8;
}
#endif

#ifndef FUNCTION_u8___c16
//Returns s8 advanced
char8_t* u8___c16(char8_t* s8, char16_t c16){
	iflike(c16<0x80) *s8=(char8_t)c16;
	else{
		if(c16<0x800) *s8++=0xC0| (char8_t)(c16>>6);
		else *s8++=0xE0| (char8_t)(c16>>12), *s8++=0x80| (char8_t)(c16>>6)&0x3F;
		*s8=0x80| (char8_t)c16&0x3F;
	}
	return s8+1;
}
#endif

#ifndef FUNCTION_str16___stru8
void str16___stru8(char16_t* s1, const char8_t* s2){
	while(*s2!='\0'){s2=c16___u8(s1,s2); s1++;}
	*s1=0;
}
#endif

#ifndef FUNCTION_str16___stru8n
void str16___stru8n(char16_t* s1, const char8_t* s2, u16int n){
	while(n && *s2!='\0'){n--; s2=c16___u8(s1,s2); s1++;}
	if(n) *s1=0;
}
#endif

#ifndef FUNCTION_stru8___str8
int stru8___str8(char8_t* s8, const char8_t* s1){
	if(s8==NULL){
		uint k=0;
		do{ char8_t c8=*s1++;
			k+=1+(c8&0x80);
			if(c8==u'\0') break;
		}while(1);
		return (int)k;
	}

	char8_t *ptr=s8;
	while(*s1!=u'\0') ptr=u8___c16(ptr,*s1++);
	*ptr++='\0';
	return (pdif)(ptr-s8);
}
#endif

#ifndef FUNCTION_stru8___stru16
int stru8___str16(char8_t* s8, const char16_t* s16){
	if(s8==NULL){
		uint k=0;
		do{ char16_t c16=*s16++;
			k+=1+(c16&~0x7F)+(c16&~0x7FF);
			if(c16==u'\0') break;
		}while(1);
		return (int)k;
	}

	char8_t *ptr=s8;
	while(*s16!=u'\0') ptr=u8___c16(ptr,*s16++);
	*ptr++='\0';
	return (pdif)(ptr-s8);
}
#endif

#ifndef FUNCTION_stru8___stru16n
int stru8___str16n(char8_t* s8, const char16_t* s16, u16int n){
	char8_t *ptr=s8, *pfin=s8;
	if(n>=3){
		pfin-=3;
		while(ptr<=pfin && *s16!=u'\0') ptr=u8___c16(ptr,*s16++);
		pfin+=3;
	}
	ifunlike(ptr==pfin) return n; //ptr ha terminado justo tras el final del array
	if(*s16!=u'\0'){ //ptr tiene 1 o 2 espacios libres aún
		char8_t c8[4], *pc=c8;
		u8___c16(pc,*s16); //Do not advance s16 till we know the transformed character will be stored
		if(ptr+(pc-&c8[0])<=pfin){
			s16++;
			*ptr++=c8[0], pc--; if(pc!=c8) *ptr++=c8[1];
			if(ptr==pfin) return n;
			else if(*s16!=u'\0'){ //queda 1 espacio libre
				u8___c16(pc,*s16);
				if(pc==&c8[1]){*ptr=c8[0]; return n;}
			}
		}
	}
	if(*s16==u'\0') *ptr++='\0';
	return (pdif)(ptr-s8);
}
#endif

#ifndef FUNCTION_stru8___stru16n_alloc
char8_t* stru8___str16n_alloc(char8_t* s2, const char16_t* s1, u16int n){
	uint k=(uint)stru8___str16(NULL,s1);
	if(k<=n){stru8___str16(s2,s1); return s2;}

	char8_t *s8=n_malloc(char8_t,k);
	iflike(s8!=NULL) stru8___str16(s8,s1);
	return s8;
}
#endif

#undef FUNCTION_double___str16
#undef FUNCTION_vfdouble___sr16
#undef FUNCTION_uint___str16
#undef FUNCTION_ssint___str16
#undef FUNCTION_hex___str16
#undef FUNCTION_oct___str16
#undef FUNCTION_bin___str16
#undef FUNCTION_basedinteger___str16
#undef FUNCTION_str16___uint
#undef FUNCTION_str16___t_min
#undef FUNCTION_c16___u8
#undef FUNCTION_u8___c16
#undef FUNCTION_str16___stru8
#undef FUNCTION_str16___stru8n
#undef FUNCTION_stru8___str8
#undef FUNCTION_stru8___stru16
#undef FUNCTION_stru8___stru16n
#undef FUNCTION_stru8___stru16n_alloc

#else
#undef IGNORE_ALL
#endif

/*If sb is NULL it returns the number of chars needed to store the string, including
the terminating '\0' character. Otherwise it assumes sb has space enough and
returns the number of chars written to sb. In either case, if an error occurs the
function returns -1. */
/* int mbstring___c16string(char8_t* sb, const char16_t* s16){
	mbstate_t mbs;
	zeroset_uint(&mbs,uintsizeof(mbs));

	const char16_t *ptr16=s16-1;
	if(sb==NULL){
		uint k=0;
		char mbchar[8]; //>=MB_CUR_MAX
		do{ ptr16++;
		int i=(int)c16rtomb(mbchar,*ptr16,&mbs);
		ifunlike(i<0) return -1;
		k+=i;
		}while(*ptr16!=u'\0');
		return (int)k;
	}

	char* ptr=(char*)sb;
	do{ ptr16++;
	int i=(int)c16rtomb(ptr,*ptr16,&mbs);
	ifunlike(i<0) return -1;
	ptr+=i;
	}while(*ptr16!=u'\0');
	return (int)(pdif)((char8_t*)ptr-sb);
}*/
