#ifndef TypeR

#define TypeR float
#define resuelve_sistema_sim_t resuelve_sistema_sim_t_fl
#define resuelve_sistema_sim_t_2 resuelve_sistema_sim_t_2_fl
#include "resuelve_sistema.c"
#undef TypeR
#undef resuelve_sistema_sim_t
#undef resuelve_sistema_sim_t_2

#define TypeR double
#define resuelve_sistema_sim_t resuelve_sistema_sim_t_dbl
#define resuelve_sistema_sim_t_2 resuelve_sistema_sim_t_2_dbl
#include "resuelve_sistema.c"
#undef TypeR
#undef resuelve_sistema_sim_t
#undef resuelve_sistema_sim_t_2

#else

int resuelve_sistema_sim_t(TypeR* N, TypeR* L, uint n){
	int nret=0;

	TypeR *pN=N+((n*(n+1))>>1)-1;
	TypeR *pL=L+n-1;
	for(cint i=n-1;;){
		ifunlike(!(*pN>0)) nret=ATINVSIM_NEG;
		{TypeR auxb=1/ *pN;
		*pN=auxb; *pL*=auxb;}
		if(!i) break;
		TypeR aux=-*pN--;
		{TypeR auxb=-*pL--;
		TypeR *pB=pN;
		inner_loopn(i,*pL--+=auxb**pB--);}
		pL+=i;
		TypeR *pNb=pN-i;
		for(cint j=i--;j;){
			TypeR auxb=aux**pN;
			TypeR *pB=pN;
			inner_loopn(j--,*pNb--+=auxb**pB--);
			*pN--=auxb;
		}
	};
	for(cint i=1;i<n;){
		pN++;
		TypeR aux=0;
		inner_loopn(i,aux+=*pN++**pL++);
		*pL+=aux; pL+=i++;
	}
	return nret;
}

int resuelve_sistema_sim_t_2(TypeR* N, TypeR* L1, TypeR* L2, uint n){
	int nret=0;

	TypeR *pN=N+((n*(n+1))>>1)-1;
	TypeR *pL1=L1+n-1,
			*pL2=L2+n-1;
	for(cint i=n-1;;){
		ifunlike(!(*pN>0)) nret=ATINVSIM_NEG;
		{TypeR auxb=1/ *pN;
		*pN=auxb; *pL1*=auxb; *pL2*=auxb;}
		if(!i) break;
		TypeR aux=-*pN--;
		{TypeR auxb=-*pL1--;
		TypeR *pB=pN;
		inner_loopn(i,*pL1--+=auxb**pB--);}
		pL1+=i;
		{TypeR auxb=-*pL2--;
		TypeR *pB=pN;
		inner_loopn(i,*pL2--+=auxb**pB--);}
		pL2+=i;

		TypeR *pNb=pN-i;
		for(cint j=i--;j;){
			TypeR auxb=aux**pN;
			TypeR *pB=pN;
			inner_loopn(j--,*pNb--+=auxb**pB--);
			*pN--=auxb;
		}
	};
	for(cint i=1;i<n;){
		pN++;
		TypeR aux1=0, aux2=0;
		inner_loopn(i, (aux1+=*pN**pL1++, aux2+=*pN++**pL2++));
		*pL1+=aux1; pL1-=i;
		*pL2+=aux2; pL2-=i++;
	}
	return nret;
}

#endif //TypeR
